import 'package:free_list/free_list.dart';

main() {

  // Create a free list of strings (lame example) with a max size of 3
  var freeList = new FreeList<String>.max(() {
    return "super expensive resource";
  }, 3);

  // Acquire 3 resources from the free list
  var res1 = freeList.acquire();
  var res2 = freeList.acquire();
  var res3 = freeList.acquire();
  print('res1 ${res1}');
  print('res2 ${res2}');
  print('res3 ${res3}');
  print('current size ${freeList.size}');

  // Restore the 3 resources to the free list
  freeList.release(res1);
  freeList.release(res2);
  freeList.release(res3);
  print('current size ${freeList.size}');

  // Acquire 4 resources from the free list
  var res4 = freeList.acquire();
  var res5 = freeList.acquire();
  var res6 = freeList.acquire();
  var res7 = freeList.acquire();
  print('res4 ${res4}');
  print('res5 ${res5}');
  print('res6 ${res6}');
  print('res7 ${res7}');
  print('current size ${freeList.size}');

  // Restore the 4 resources to the free list
  freeList.release(res4);
  freeList.release(res5);
  freeList.release(res6);
  freeList.release(res7);
  print('current size ${freeList.size}');

}